//Utilitaire pour lire/crire alternativement en RAM ou dans un fichier
typedef struct		{
	void *ptr;
	FILE *file;
	int offset, maxSize;
} VIRTUAL_FILE;

VIRTUAL_FILE *VirtualFileOpen(void *param1, int param2, int type, const char *mode);
void VirtualFileClose(VIRTUAL_FILE *f);
int VirtualFileWrite(const void *ptr, size_t size, size_t n, VIRTUAL_FILE* f);
int VirtualFileRead(void *ptr, size_t size, size_t n, VIRTUAL_FILE* f);
int VirtualFileGetc(VIRTUAL_FILE *f);
int VirtualFilePutc(int caractere, VIRTUAL_FILE *f);
void VirtualFilePuts(const char *s, VIRTUAL_FILE *f);
int VirtualFileSeek(VIRTUAL_FILE *f, int offset, int whence);
int VirtualFileEof(VIRTUAL_FILE *f);
char *VirtualFileGets(char *str, int maxLen, VIRTUAL_FILE *f);

enum {VF_MEMORY=1, VF_FILE=2};
