#ifndef VIDEOGU_H
#define VIDEOGU_H

typedef struct
{
	char scrBuffer[256*192*2];
	uint16 pal[256];
} screen_t;

extern screen_t Screen;

void VideoGuInit(void);

void VideoGuTerm(void);

void VideoGuUpdate(int nFrame, int fullScreen);
void VideoGuUpdate_Core(int fullScreen);

void VideoGuScreenClear(void);

#endif
